<?php
// $Id: webservices.hooks.inc,v 1.1.2.1 2009/07/07 23:51:09 brmassa Exp $
/**
 * @author Web Services Dev Team
 * @file
 *  Provides a generic but powerful API for web services.
 */

/**
 * Implementation of hook_permission().
 */
function webservices_permission() {
  // Basic permissions
  $perms = array(
    'access crossdomain.xml' => array(
      'title'       => t('Access crossdomain.xml'),
    ),
    'integrate external application' => array(
      'title'       => t('Integrate External Application'),
    ),
    'administer webservices' => array(
      'title'       => t('Administer Web Services'),
    ),
  );

  // Permission for those services that had not determined a
  // specific permission
  $methods = module_invoke_all('webservices_info');
  foreach ($methods as $key => $method) {
    if (!isset($methods[$key]['#access callback'])) {
      if (!isset($methods[$key]['#access arguments'])) {
        $perms['access '. $methods[$key]['#method'] .' webservice'] = array(
          'title'       => t('Access %service webservice', array('%service' => $methods[$key]['#method'])),
        );
      }
    }
  }

  return $perms;
}


/**
 * Implementation of hook_menu().
 */
function webservices_menu() {
  $items['admin/build/webservices'] = array(
    'access arguments'  => array('administer webservices'),
    'description'       => 'Allows external applications to communicate with Drupal.',
    'file'              => 'webservices.admin.inc',
    'page callback'     => '_webservices_admin_service_list',
    'title'             => 'Web services',
  );
  $items['admin/build/webservices/%webservices_service'] = array(
    'access arguments'  => array('administer webservices'),
    'file'              => 'webservices.admin.inc',
    'page callback'     => 'drupal_get_form',
    'page arguments'    => array('_webservices_admin_service_test', 3),
    'title'             => 'Web services',
    'type'              => MENU_CALLBACK,
  );
  $items['admin/build/webservices/js'] = array(
    'access arguments'  => array('administer webservices'),
    'file'              => 'webservices.admin.inc',
    'page callback'     => '_webservices_admin_service_test_js',
    'type'              => MENU_CALLBACK,
  );
  $items['admin/settings/webservices'] = array(
    'access arguments'  => array('administer webservices'),
    'description'       => 'Configure web services settings.',
    'file'              => 'webservices.admin.inc',
    'page callback'     => 'drupal_get_form',
    'page arguments'    => array('_webservices_admin_settings'),
    'title'             => 'Web services',
  );
  $items['crossdomain.xml'] = array(
    'access arguments'  => array('access webservices'),
    'file'              => 'webservices.inc',
    'page callback'     => '_webservices_crossdomain_xml',
    'type'              => MENU_CALLBACK,
  );
  $items['webservice/%'] = array(
    'access callback'   => TRUE,
    'file'              => 'webservices.inc',
    'page callback'     => '_webservices_server',
    'page arguments'    => array(1),
    'title'             => 'Web services',
    'type'              => MENU_CALLBACK,
  );

  return $items;
}
