<?php
// $Id: wsapi.hooks.inc,v 1.1.2.1 2009/07/07 23:51:09 brmassa Exp $
/**
 * @author Web Services Dev Team
 * @file
 *  Automatically create the API help pages about your web services.
 */

/**
 * Implementation of hook_permission().
 */
function wsapi_permission() {
  return array(
    'see ws help' => array(
      'title' => 'See Web Services API help pages'
    ),
    'administer ws help' => array(
      'title' => 'Administer Web Services API help pages'
    ),
  );
}

/**
 * Implementation of hook_menu().
 */
function wsapi_menu() {
  $items['admin/settings/webservices/api'] = array(
    'access arguments'  => array('administer ws help'),
    'file'              => 'wsapi.admin.inc',
    'page callback'     => 'drupal_get_form',
    'page arguments'    => array('_wsapi_settings'),
    'title'             => 'Web Services API',
  );
  $items['webservices/api'] = array(
    'access arguments'  => array('see ws help'),
    'file'              => 'wsapi.inc',
    'page callback'     => '_wsapi_api',
    'title'             => 'Web Services API',
  );
  $items['webservices/api/authentication/%'] = array(
    'access arguments'  => array('see ws help'),
    'file'              => 'wsapi.inc',
    'page callback'     => '_wsapi_authentication',
    'page arguments'    => array(3),
    'type'              => MENU_CALLBACK
  );
  $items['webservices/api/server/%'] = array(
    'access arguments'  => array('see ws help'),
    'file'              => 'wsapi.inc',
    'page callback'     => '_wsapi_server',
    'page arguments'    => array(3),
    'type'              => MENU_CALLBACK
  );
  $items['webservices/api/service/%'] = array(
    'access arguments'  => array('see ws help'),
    'file'              => 'wsapi.inc',
    'page callback'     => '_wsapi_service',
    'page arguments'    => array(3),
    'type'              => MENU_CALLBACK
  );

  return $items;
}

/**
 * Implementation of hook_theme().
 */
function wsapi_theme() {
  return array(
    'wsapi' => array(
      'arguments' => array('show'),
    ),
    'wsapi_authentication' => array(
      'arguments' => array('show'),
    ),
    'wsapi_server' => array(
      'arguments' => array('show'),
    ),
    'wsapi_service' => array(
      'arguments' => array('show'),
    ),
  );
}
